/*Copyright (C) 2006  Jean-Franois Geyelin*/

// Header File
// Created 1/14/2006; 2:13:21 AM

typedef struct {
	short	x;
	short	y;
}Coord;

typedef struct {
	short	x;
	short y;
}SmallCoord;

typedef struct {
	unsigned char array[64][64];
 	unsigned char *waypoints;
 	long startingCoordX;
 	long startingCoordY; 	
 	long startingAngle;
 	unsigned char name[32];
}Map;

typedef struct {
	long x;
	long y;
	short radius;
	short maxRadius;
	short dRadius;
	short on;
}Explosion;

typedef struct {
	Map *map;
	unsigned long	x;
	unsigned long	y;
	unsigned long previousX;
	unsigned long	previousY;
	long vx;
	long vy;
	long angle;
	long stearingAngle;
	long shiftedAngle;
	//long orientation;
	long speed;
	long shiftedSpeed;
	//char waypoint;
	unsigned short bestFPL;//Frame per lap;
	unsigned short currentFPL; 
	unsigned short lastFPL;
	//unsigned char currentWaypoint;
	unsigned char nextWaypoint;
	unsigned char numberOfWaypoints;
	unsigned char keyPressed;
	unsigned char mapNumber;
	unsigned char raceMode;
	unsigned char numberOfLapDone;
	unsigned char hasFinishedRacing;
}Player;

typedef struct {
	unsigned short t[16];
}Tile;

typedef struct {
	unsigned short data[16*16*NUMBER_OF_TILES];
}DecompressedTiles;

typedef struct {
	unsigned short data[16*NUMBER_OF_TILES];
}DecompressedMasks;

typedef struct {
	unsigned short data[GHOST_LENGTH];
}GhostKeyPressed;

typedef struct {
	long length;
	GhostKeyPressed gkp;
	char hasContent;
}GhostSave;

typedef struct {
	unsigned short bestLap;
	unsigned short best3Laps;
	unsigned short attemps;
	unsigned short laps;
}Scores;

typedef struct {
	GhostSave ghostSave[NUMBER_OF_MAP];
	Scores scores[NUMBER_OF_MAP];
	unsigned char wantToShowGhost;
}SaveFile;

typedef struct {
	unsigned short *data;
	unsigned short length;
	unsigned char ghostDataKeys;
	unsigned char ghostDataTime;
}GhostVariables;

typedef struct {
	Player p;
	Player ghostPlayer;
	
	//Explosion explosions[NUMBER_OF_EXPLOSIONS];
	DecompressedTiles *decompressedTiles;
	DecompressedMasks *decompressedMasks;
	unsigned short rotatedTile[NUMBER_OF_TILES*2*16];
	unsigned char map[128][128];
	char lcdSave[LCD_SIZE];
	char buffer[LCD_SIZE];
	char collisionBuffer[30*16*3];
	unsigned char waypointArray[128][128];
	GhostKeyPressed gkp;
	GhostVariables writeGhostVariables;
	GhostVariables readGhostVariables;
	SaveFile *saveFile;
	char playGhost;
	char recordGhost;
	char showGhost;
}AllocatedMem;

